#include "iictest.h"						
/**************************************
延时5微秒(STC90C52RC@12M)
不同的工作环境,需要调整此函数，注意时钟过快时需要修改
当改用1T的MCU时,请调整此延时函数
**************************************/
void Delay5us()
{
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
}

/**************************************
延时5毫秒(STC90C52RC@12M)
不同的工作环境,需要调整此函数
当改用1T的MCU时,请调整此延时函数
**************************************/
void Delay5ms()
{
    WORD n = 560;

    while (n--);
}

/**************************************
起始信号
**************************************/
void HMC5883_Start()
{
    SDA = 1;                    //拉高数据线
    SCL = 1;                    //拉高时钟线
    Delay5us();                 //延时
    SDA = 0;                    //产生下降沿
    Delay5us();                 //延时
    SCL = 0;                    //拉低时钟线
}

/**************************************
停止信号
**************************************/
void HMC5883_Stop()
{
    SDA = 0;                    //拉低数据线
    SCL = 1;                    //拉高时钟线
    Delay5us();                 //延时
    SDA = 1;                    //产生上升沿
    Delay5us();                 //延时
}

/**************************************
发送应答信号
入口参数:ack (0:ACK 1:NAK)
**************************************/
void HMC5883_SendACK(bit ack)
{
    SDA = ack;                  //写应答信号
    SCL = 1;                    //拉高时钟线
    Delay5us();                 //延时
    SCL = 0;                    //拉低时钟线
    Delay5us();                 //延时
}

/**************************************
接收应答信号
**************************************/
bit HMC5883_RecvACK()
{
    SCL = 1;                    //拉高时钟线
    Delay5us();                 //延时
    CY = SDA;                   //读应答信号
    SCL = 0;                    //拉低时钟线
    Delay5us();                 //延时

    return CY;
}

/**************************************
向IIC总线发送一个字节数据
**************************************/
void HMC5883_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8位计数器
    {
        dat <<= 1;              //移出数据的最高位
        SDA = CY;               //送数据口
        SCL = 1;                //拉高时钟线
        Delay5us();             //延时
        SCL = 0;                //拉低时钟线
        Delay5us();             //延时
    }
    HMC5883_RecvACK();
}

/**************************************
从IIC总线接收一个字节数据
**************************************/
BYTE HMC5883_RecvByte()
{
    BYTE i;
    BYTE dat = 0;

    SDA = 1;                    //使能内部上拉,准备读取数据,
    for (i=0; i<8; i++)         //8位计数器
    {
        dat <<= 1;
        SCL = 1;                //拉高时钟线
        Delay5us();             //延时
        dat |= SDA;             //读数据               
        SCL = 0;                //拉低时钟线
        Delay5us();             //延时
    }
    return dat;
}

//************************写入单字节数据***************************

void Single_Write_HMC5883(uchar REG_Address,uchar REG_data)
{
    HMC5883_Start();                  //起始信号
    HMC5883_SendByte(SlaveAddress);   //发送设备地址+写信号
    HMC5883_SendByte(REG_Address);    //内部寄存器地址，请参考中文pdf 
    HMC5883_SendByte(REG_data);       //内部寄存器数据，请参考中文pdf
    HMC5883_Stop();                   //发送停止信号
}

//************************读取内部寄存器*************************
//uchar Single_Read_HMC5883(uchar REG_Address)
//{   
//	uchar REG_data;
//  HMC5883_Start();                          //起始信号
//  HMC5883_SendByte(SlaveAddress);           //发送设备地址+写信号
//  HMC5883_SendByte(REG_Address);            //发送存储单元地址，从0开始	
//  HMC5883_Start();                          //起始信号
//  HMC5883_SendByte(SlaveAddress+1);         //发送设备地址+读信号
//  REG_data=HMC5883_RecvByte();              //读出寄存器数据
//	HMC5883_SendACK(1);   
//	HMC5883_Stop();                           //停止信号
//  return REG_data; 
//}

//******************************************************
//连续读出HMC5883内部角度数据，地址范围0x3~0x5
//******************************************************
void Multiple_Read_HMC5883(void)
{   uchar i;
    HMC5883_Start();                          //起始信号
    HMC5883_SendByte(SlaveAddress);           //发送设备地址+写信号
    HMC5883_SendByte(0x03);                   //发送存储单元地址，从0x3开始	
    HMC5883_Start();                          //起始信号
    HMC5883_SendByte(SlaveAddress+1);         //发送设备地址+读信号
	 for (i=0; i<6; i++)                      //连续读取6个地址数据，存储中BUF
    {
        BUF[i] = HMC5883_RecvByte();          //BUF[0]存储数据
        if (i == 5)
        {
           HMC5883_SendACK(1);                //最后一个数据需要回NOACK
        }
        else
        {
          HMC5883_SendACK(0);                //回应ACK
       }
   }
    HMC5883_Stop();                          //停止信号
    Delay5ms();
}

//初始化HMC5883，根据需要请参考pdf进行修改****
void Init_HMC5883()
{
     Single_Write_HMC5883(0x02,0x00);  //
}
//*********************************************************
//主程序********
//*********************************************************
void main()
{
	// bit sign_bit;
	unsigned int i;
	int X,Y,Z;
	double Angle_XY=0,Angle_XZ=0,Angle_YZ=0;

	Delay_ms(500);			
	InitLcd();
	Init_HMC5883();
	while(1)            //循环
	{ 
		Multiple_Read_HMC5883();      //连续读出数据，存储在BUF中
//---------显示X轴
		X=BUF[0] << 8 | BUF[1]; //Combine MSB and LSB of X Data output register  最高有效位
		Z=BUF[2] << 8 | BUF[3]; //Combine MSB and LSB of Z Data output register
		Y=BUF[4] << 8 | BUF[5]; //Combine MSB and LSB of Y Data output register

		if(X>0x7fff)X-=0xffff;	  
		if(Y>0x7fff)Y-=0xffff;
		if(Z>0x7fff)Z-=0xffff;	 

		Angle_XY= atan2((double)Y,(double)X) * (180 / 3.14159265) + 180; //计算XY平面角度
		Angle_XY*=10;
		Conversion(Angle_XY);       //计算XY平面角度数据和显示
		Display_One_Char(0,0,'X');
		Display_One_Char(1,0,'Y');
		Display_One_Char(2,0,':'); 
		Display_One_Char(3,0,qian); 
		Display_One_Char(4,0,bai); 
		Display_One_Char(5,0,shi); 
		Display_One_Char(6,0,'.'); 
		Display_One_Char(7,0,ge); 
		
		Angle_XZ= atan2((double)Z,(double)X) * (180 / 3.14159265) + 180; //计算XZ平面角度
		Angle_XZ*=10;
		Conversion(Angle_XZ);       //计算XZ平面角度数据和显示
		Display_One_Char(9,0,'X');
		Display_One_Char(10,0,'Z');
		Display_One_Char(11,0,':'); 
		Display_One_Char(12,0,qian); 
		Display_One_Char(13,0,bai); 
		Display_One_Char(14,0,shi); 
		Display_One_Char(15,0,'.'); 
		Display_One_Char(16,0,ge); 
		
		Angle_YZ= atan2((double)Z,(double)Y) * (180 / 3.14159265) + 180; //计算YZ平面角度
		Angle_YZ*=10;
		Conversion(Angle_YZ);       //计算YZ平面角度数据和显示
		Display_One_Char(0,1,'Y');
		Display_One_Char(1,1,'Z');
		Display_One_Char(2,1,':'); 
		Display_One_Char(3,1,qian); 
		Display_One_Char(4,1,bai); 
		Display_One_Char(5,1,shi); 
		Display_One_Char(6,1,'.'); 
		Display_One_Char(7,1,ge); 

    for (i=0;i<10000;i++);   //延时                   
  }
} 




